



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Go语言项目的错误和异常管理 via 达达</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Go语言项目的错误和异常管理 via 达达</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-01-31 11:40:26 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p><a href="http://1234n.com/?post/j02rfx" rel="external nofollow noreferrer">Go语言项目的错误和异常管理</a></p>
<p>最近连续遇到朋友问我项目里错误和异常管理的事情，之前也多次跟团队强调过错误和异常管理的一些概念，所以趁今天有动力就赶紧写一篇Go语言项目错误和异常管理的经验分享。</p>
<p>首先我们要理清：什么是错误、什么是异常、为什么需要管理。然后才是怎样管理。</p>
<p>错误和异常从语言机制上面讲，就是error和panic的区别，放到别的语言也一样，别的语言没有error类型，但是有错误码之类的，没有panic，但是有throw之类的。</p>
<p>在语言层面它们是两种概念，导致的是两种不同的结果。如果程序遇到错误不处理，那么可能进一步的产生业务上的错误，比如给用户多扣钱了，或者进一步产生了异常；如果程序遇到异常不处理，那么结果就是进程异常退出。</p>
<p>在项目里面是不是应该处理所有的错误情况和捕捉所有的异常呢？我只能说，你可以这么做，但是估计效果不会太好。我的理由是：</p>
<pre class="prettyprint linenums"><code>如果所有东西都处理和记录，那么重要信息可能被淹没在信息的海洋里。<br />
不应该处理的错误被处理了，很容易导出BUG暴露不出来，直到出现更严重错误的时候才暴露出问题，到时候排查就很困难了，因为已经不是错误的第一现场。<br />
</code></pre>
<p>所以错误和异常最好能按一定的规则进行分类和管理，在第一时间能暴露错误和还原现场。</p>
<p>对于错误处理，Erlang有一个很好的概念叫速错，就是有错误第一时间暴露它。我们的项目从Erlang到Go一直是沿用这一设计原则。但是应用这个原则的前提是先得区分错误和异常这两个概念。</p>
<p>错误和异常上面已经提到了，从语言机制层面比较容易区分它们，但是语言取决于人为，什么情况下用错误表达，什么情况下用异常表达，就得有一套规则，否则很容易出现全部靠异常来做错误处理的情况，似乎Java项目特别容易出现这样的设计。</p>
<p>这里我先假想有这样一个业务：游戏玩家通过购买按钮，用铜钱购买宝石。</p>
<p>在实现这个业务的时候，程序逻辑会进一步分化成客户端逻辑和服务端逻辑，客户端逻辑又进一步因为设计方式的不同分化成两种结构：胖客户端结构、瘦客户端结构。</p>
<p>胖客户端结构，有更多的本地数据和懂得更多的业务逻辑，所以在胖客户端结构的应用中，以上的业务会实现成这样：客户端检查缓存中的铜钱数量，铜钱数量足够的时候购买按钮为可用的亮起状态，用户点击购买按钮后客户端发送购买请求到服务端；服务端收到请求后校验用户的铜钱数量，如果铜钱数量不足就抛出异常，终止请求过程并断开客户端的连接，如果铜钱数量足够就进一步完成宝石购买过程，这里不继续描述正常过程。</p>
<p>因为正常的客户端是有一步数据校验的过程的，所以当服务端收到不合理的请求（铜钱不足以购买宝石）时，抛出异常比返回错误更为合理，因为这个请求只可能来自两种客户端：外挂或者有BUG的客户端。如果不通过抛出异常来终止业务过程和断开客户端连接，那么程序的错误就很难被第一时间发现，攻击行为也很难被发现。</p>
<p>我们再回头看瘦客户端结构的设计，瘦客户端不会存有太多状态数据和用户数据也不清楚业务逻辑，所以客户端的设计会是这样：用户点击购买按钮，客户端发送购买请求；服务端收到请求后检查铜钱数量，数量不足就返回数量不足的错误码，数量足够就继续完成业务并返回成功信息；客户端收到服务端的处理结果后，在界面上做出反映。</p>
<p>在这种结构下，铜钱不足就变成了业务逻辑范围内的一种失败情况，但不能提升为异常，否则铜钱不足的用户一点购买按钮都会出错掉线。</p>
<p>所以，异常和错误在不同程序结构下是互相转换的，我们没办法一句话的给所有类型所有结构的程序一个统一的异常和错误分类规则。</p>
<p>但是，异常和错误的分类是有迹可循的。比如上面提到的痩客户端结构，铜钱不足是业务逻辑范围内的一种失败情况，它属于业务错误，再比如程序逻辑上尝试请求某个URL，最多三次，重试三次的过程中请求失败是错误，重试到第三次，失败就被提升为异常了。</p>
<p>所以我们可以这样来归类异常和错误：不会终止程序逻辑运行的归类为错误，会终止程序逻辑运行的归类为异常。</p>
<p>因为错误不会终止逻辑运行，所以错误是逻辑的一部分，比如上面提到的瘦客户端结构，铜钱不足的错误就是业务逻辑处理过程中需要考虑和处理的一个逻辑分支。而异常就是那些不应该出现在业务逻辑中的东西，比如上面提到的胖客户端结构，铜钱不足已经不是业务逻辑需要考虑的一部分了，所以它应该是一个异常。</p>
<p>错误和异常的分类需要通过一定的思维训练来强化分类能力，就类似于面向对象的设计方式一样的，技术实现就摆在那边，但是要用好需要不断的思维训练不断的归类和总结，以上提到的归类方式希望可以作为一个参考，期待大家能发现更多更有效的归类方式。</p>
<p>接下来我们讲一下速错和Go语言里面怎么做到速错。</p>
<p>速错我最早接触是在做ASP.NET的时候就体验到的，当然跟Erlang的速错不完全一致，那时候也没有那么高大上的一个名字，但是对待异常的理念是一样的。</p>
<p>在.NET项目开发的时候，有经验的程序员都应该知道，不能随便re-throw，就是catch错误再抛出，原因是异常的第一现场会被破坏，堆栈跟踪信息会丢失，因为外部最后拿到异常的堆栈跟踪信息，是最后那次throw的异常的堆栈跟踪信息；其次，不能随便try catch，随便catch很容易导出异常暴露不出来，升级为更严重的业务漏洞。</p>
<p>到了Erlang时期，大家学到了速错概念，简单来讲就是：让它挂。只有挂了你才会第一时间知道错误，但是Erlang的挂，只是Erlang进程的异常退出，不会导致整个Erlang节点退出，所以它挂的影响层面比较低。</p>
<p>在Go语言项目中，虽然有类似Erlang进程的Goroutine，但是Goroutine如果panic了，并且没有recover，那么整个Go进程就会异常退出。所以我们在Go语言项目中要应用速错的设计理念，就要对Goroutine做一定的管理。</p>
<p>在我们的游戏服务端项目中，我把Goroutine按挂掉后的结果分为两类：1、挂掉后不影响其他业务或功能的；2、挂掉后业务就无法正常进行的。</p>
<p>第一类Goroutine典型的有：处理各个玩家请求的Goroutine，因为每个玩家连接各自有一个Goroutine，所以挂掉了只会影响单个玩家，不会影响整体业务进行。</p>
<p>第二类Goroutine典型的有：数据库同步用的Goroutine，如果它挂了，数据就无法同步到数据库，游戏如果继续运行下去只会导致数据回档，还不如让整个游戏都异常退出。</p>
<p>这样一分类，就可以比较清楚哪些Goroutine该做recover处理，哪些不该做recover处理了。</p>
<p>那么在做recover处理时，要怎样才能尽量保留第一现场来帮组开发者排查问题原因呢？我们项目中通常是会在最外层的recover中把错误和堆栈跟踪信息记进日志，同时把关键的业务信息，比如：用户ID、来源IP、请求数据等也一起记录进去。</p>
<p>为此，我们还特地设计了一个库，用来格式化输出堆栈跟踪信息和对象信息，项目地址：<a href="http://github.com/funny/debug" rel="external nofollow noreferrer">http://github.com/funny/debug</a></p>
<p>通篇写下来发现比我预期的长很多，所以这里我做一下归纳总结，帮组大家理解这篇文章所要表达的：</p>
<pre class="prettyprint linenums"><code>错误和异常需要分类和管理，不能一概而论<br />
错误和异常的分类可以以是否终止业务过程作为标准<br />
错误是业务过程的一部分，异常不是<br />
不要随便捕获异常，更不要随便捕获再重新抛出异常<br />
Go语言项目需要把Goroutine分为两类，区别处理异常<br />
在捕获到异常时，需要尽可能的保留第一现场的关键数据<br />
</code></pre>
<p>以上仅为一家之言，抛砖引玉，希望对大家有所帮助。</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/r93y6nw8.html">12&period;Java中Comparable接口，Readable接口和Iterable接口</a>
		</li>
						<li><a href="https://www.batexi.com/a/xq461038.html">JLOI2016 方</a>
		</li>
						<li><a href="https://www.batexi.com/a/xq4w4359.html">【POJ 3241】Object Clustering 曼哈顿距离最小生成树</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qxp70z9.html">Android事件机制之一：事件传递和消费</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pjj7rd9.html">winScp 跳板机到服务器</a>
		</li>
						<li><a href="https://www.batexi.com/a/8z1eg739.html">leetcode2&Tab; Two Sum II &ndash; Input array is sorted</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxn4g2z8.html">the evaluation period for visual studio trial edition has ended的解决方法-转发</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k16lv59.html">swift 赋值判断</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pjrvz49.html">Ruby与sass 与compass安装</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxn1v0j8.html">TCP&sol;IP详解之：Ping程序、Traceroute程序</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k136yj9.html">2013杭州网络赛D题HDU 4741&lpar;计算几何 解三元一次方程组&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pddkpy9.html">重新想象 Windows 8 Store Apps &lpar;27&rpar; - 选取器&colon; 联系人选取窗口&comma; 自定义联系人选取窗口</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2j2oox8.html">TIOBE：全球编程语言最新排名（Kotlin排名进入前50名）</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rgmo078.html">BZOJ 3198&colon; &lbrack;Sdoi2013&rsqb;spring &lbrack;容斥原理 哈希表&rsqb;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnjewyg8.html">Linux shell查询ip归属地</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4z0nej9.html">001&lowbar;Go hello world</a>
		</li>
						<li><a href="https://www.batexi.com/a/qy1k7ljq.html">ubuntu上安装multi-mechanize步骤</a>
		</li>
						<li><a href="https://www.batexi.com/a/90mgogo8.html">&period;Net 之 RPC 框架之Hprose（远程调用对象）</a>
		</li>
						<li><a href="https://www.batexi.com/a/960pmwj9.html">ajax的4个字母分别是什么意思</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnvez238.html">InnoDB启用大内存页</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/8ok37ep9.html">Shiro 缓存失效以后的一个问题</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1zyggz9.html">js中批量处理样式&mdash;&mdash;cssText的使用</a>
			</li>
						<li><a href="https://www.batexi.com/a/qvv353xq.html">认识OD的两种断点</a>
			</li>
						<li><a href="https://www.batexi.com/a/qlmpjre9.html">linux distribution是什么？</a>
			</li>
						<li><a href="https://www.batexi.com/a/qn14jrj8.html">ABC&colon; Always Be Coding&mdash;&mdash;程序员面试必</a>
			</li>
						<li><a href="https://www.batexi.com/a/96oz04y9.html">我见过的 Objective-C&comma; 讲的最通俗易懂的入门教程&period;&period;&period;&period;</a>
			</li>
						<li><a href="https://www.batexi.com/a/qyd0v2xq.html">&lbrack;Unity菜鸟&rsqb; Unity读XML</a>
			</li>
						<li><a href="https://www.batexi.com/a/90vk2lm8.html">Android：使用ViewPager实现左右滑动切换图片 &lpar;简单版&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/96oz3ky9.html">Android：反编译查看源码</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2wyknlq.html">Photoshop：路径填充边缘虚化问题</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
